Index: code/branches/presentation3/src/orxonox/controllers/AIController.cc
===================================================================
--- code/branches/presentation3/src/orxonox/controllers/AIController.cc	(revision 7107)
+++ code/branches/presentation3/src/orxonox/controllers/AIController.cc	(revision 7127)
@@ -112,5 +112,5 @@
             random = rnd(maxrand);
             if (random < 25 && (this->bShooting_))
-                this->bShooting_ = false; 
+                this->bShooting_ = false;
 
         }
@@ -127,5 +127,5 @@
             this->commandSlaves();
 
-            if  (this->specificMasterAction_ != NONE) 
+            if  (this->specificMasterAction_ != NONE)
                     this->specificMasterActionHold();
 
@@ -149,5 +149,5 @@
                  // lose master status (only if less than 4 slaves in formation)
                 random = rnd(maxrand);
-                if(random < 15/(this->slaves_.size()+1) && this->slaves_.size() < 4 ) 
+                if(random < 15/(this->slaves_.size()+1) && this->slaves_.size() < 4 )
                    this->loseMasterState();
 
Index: code/branches/presentation3/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- code/branches/presentation3/src/orxonox/controllers/ArtificialController.cc	(revision 7107)
+++ code/branches/presentation3/src/orxonox/controllers/ArtificialController.cc	(revision 7127)
@@ -91,5 +91,5 @@
         {
             this->removeFromFormation();
-            
+
             for (ObjectList<ArtificialController>::iterator it = ObjectList<ArtificialController>::begin(); it; ++it)
             {
@@ -101,5 +101,5 @@
                         it->myMaster_ = 0;
                     }
-                    
+
                     while (true)
                     {
@@ -139,10 +139,10 @@
         {
             Controller* controller = 0;
-            
+
             if (it->getController())
                 controller = it->getController();
             else if (it->getXMLController())
                 controller = it->getXMLController();
-                
+
             if (!controller)
                 continue;
@@ -162,5 +162,5 @@
 
     /**
-        @brief Get all masters to do a "specific master action" 
+        @brief Get all masters to do a "specific master action"
         @param action which action to perform (integer, so it can be called with a console command (tmp solution))
     */
@@ -170,10 +170,10 @@
         {
             Controller* controller = 0;
-            
+
             if (it->getController())
                 controller = it->getController();
             else if (it->getXMLController())
                 controller = it->getXMLController();
-                
+
             if (!controller)
                 continue;
@@ -204,10 +204,10 @@
         {
             Controller* controller = 0;
-            
+
             if (it->getController())
                 controller = it->getController();
             else if (it->getXMLController())
                 controller = it->getXMLController();
-                
+
             if (!controller)
                 continue;
@@ -252,10 +252,10 @@
         {
             Controller* controller = 0;
-            
+
             if (it->getController())
                 controller = it->getController();
             else if (it->getXMLController())
                 controller = it->getXMLController();
-                
+
             if (!controller)
                 continue;
@@ -280,10 +280,10 @@
         {
             Controller* controller = 0;
-            
+
             if (it->getController())
                 controller = it->getController();
             else if (it->getXMLController())
                 controller = it->getXMLController();
-                
+
             if (!controller)
                 continue;
@@ -303,5 +303,5 @@
     void ArtificialController::changedControllableEntity()
     {
-        if (!this->getControllableEntity()) 
+        if (!this->getControllableEntity())
             this->removeFromFormation();
     }
@@ -400,5 +400,5 @@
                 this->myMaster_->slaves_.erase(it);
         }
-        
+
         this->myMaster_ = 0;
         this->state_ = FREE;
@@ -423,10 +423,10 @@
             //has it an ArtificialController?
             Controller* controller = 0;
-            
+
             if (it->getController())
                 controller = it->getController();
             else if (it->getXMLController())
                 controller = it->getXMLController();
-                
+
             if (!controller)
                 continue;
@@ -476,5 +476,5 @@
         @brief Commands the slaves of a master into a formation. Sufficiently fast not to be called within tick. Initiated by a master.
     */
-    void ArtificialController::commandSlaves() 
+    void ArtificialController::commandSlaves()
     {
         if(this->state_ != MASTER) return;
@@ -489,5 +489,5 @@
             this->slaves_.front()->setTargetPosition(dest);
         }
-        else 
+        else
         {
             dest += 1.0f*orient*WorldEntity::BACK;
@@ -592,5 +592,5 @@
     bool ArtificialController::forcedFree()
     {
-        if(this->freedomCount_ > 0) 
+        if(this->freedomCount_ > 0)
         {
             this->freedomCount_--;
@@ -606,5 +606,5 @@
         if(this->state_ != MASTER) return;
 
-        if (specificMasterActionHoldCount_ == 0) 
+        if (specificMasterActionHoldCount_ == 0)
          {
             this->specificMasterAction_ = NONE;
@@ -677,5 +677,5 @@
         if (!always)
             this->specificMasterActionHoldCount_ = secondsToFollow;
-        else 
+        else
             this->specificMasterActionHoldCount_ = INT_MAX; //for now...
 
@@ -698,5 +698,5 @@
 
             currentHumanController = orxonox_cast<NewHumanController*>(it->getController());
-            if(currentHumanController) 
+            if(currentHumanController)
             {
                 if (!ArtificialController::sameTeam(this->getControllableEntity(), *it, this->getGametype())) continue;
Index: code/branches/presentation3/src/orxonox/controllers/ArtificialController.h
===================================================================
--- code/branches/presentation3/src/orxonox/controllers/ArtificialController.h	(revision 7107)
+++ code/branches/presentation3/src/orxonox/controllers/ArtificialController.h	(revision 7127)
@@ -64,5 +64,5 @@
             inline int getFormationSize() const
                 { return this->maxFormationSize_; }
-                
+
             inline void setPassive(bool passive)
                 { this->passive_ = passive; }
Index: code/branches/presentation3/src/orxonox/controllers/DroneController.h
===================================================================
--- code/branches/presentation3/src/orxonox/controllers/DroneController.h	(revision 7107)
+++ code/branches/presentation3/src/orxonox/controllers/DroneController.h	(revision 7127)
@@ -52,5 +52,5 @@
             DroneController(BaseObject* creator);
             virtual ~DroneController();
-            
+
             virtual void tick(float dt); //!< The controlling happens here. This method defines what the controller has to do each tick.
 