Index: /code/branches/consolecommands3/src/libraries/core/ConfigFileManager.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/ConfigFileManager.cc	(revision 7189)
+++ /code/branches/consolecommands3/src/libraries/core/ConfigFileManager.cc	(revision 7190)
@@ -543,12 +543,14 @@
     }
 
-    bool SettingsConfigFile::config(const std::string& section, const std::string& entry, const std::string& value)
-    {
-        return this->configImpl(section, entry, value, &ConfigValueContainer::set);
-    }
-
-    bool SettingsConfigFile::tconfig(const std::string& section, const std::string& entry, const std::string& value)
-    {
-        return this->configImpl(section, entry, value, &ConfigValueContainer::tset);
+    void SettingsConfigFile::config(const std::string& section, const std::string& entry, const std::string& value)
+    {
+        if (!this->configImpl(section, entry, value, &ConfigValueContainer::set))
+            COUT(1) << "Error: Config value \"" << entry << "\" in section \"" << section << "\" doesn't exist." << std::endl;
+    }
+
+    void SettingsConfigFile::tconfig(const std::string& section, const std::string& entry, const std::string& value)
+    {
+        if (!this->configImpl(section, entry, value, &ConfigValueContainer::tset))
+            COUT(1) << "Error: Config value \"" << entry << "\" in section \"" << section << "\" doesn't exist." << std::endl;
     }
 
Index: /code/branches/consolecommands3/src/libraries/core/ConfigFileManager.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/ConfigFileManager.h	(revision 7189)
+++ /code/branches/consolecommands3/src/libraries/core/ConfigFileManager.h	(revision 7190)
@@ -331,6 +331,6 @@
             void clean(bool bCleanComments = false); // tolua_export
 
-            bool config(const std::string& section, const std::string& entry, const std::string& value); // tolua_export
-            bool tconfig(const std::string& section, const std::string& entry, const std::string& value); // tolua_export
+            void config(const std::string& section, const std::string& entry, const std::string& value); // tolua_export
+            void tconfig(const std::string& section, const std::string& entry, const std::string& value); // tolua_export
             std::string getConfig(const std::string& section, const std::string& entry); // tolua_export
 
Index: /code/branches/consolecommands3/src/libraries/network/ClientConnection.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/network/ClientConnection.cc	(revision 7189)
+++ /code/branches/consolecommands3/src/libraries/network/ClientConnection.cc	(revision 7190)
@@ -149,6 +149,8 @@
   uint32_t ClientConnection::getRTT()
   {
-    assert(server_);
-    return server_->roundTripTime;
+    if (server_)
+        return server_->roundTripTime;
+    else
+        return 0;
   }
 
Index: /code/branches/consolecommands3/src/libraries/network/Host.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/network/Host.cc	(revision 7189)
+++ /code/branches/consolecommands3/src/libraries/network/Host.cc	(revision 7190)
@@ -89,5 +89,5 @@
   }
 
-  bool Host::Chat(const std::string& message)
+  void Host::Chat(const std::string& message)
   {
     if(instances_s.size()==0)
@@ -95,5 +95,5 @@
       for (ObjectList<ChatListener>::iterator it = ObjectList<ChatListener>::begin(); it != ObjectList<ChatListener>::end(); ++it)
         it->incomingChat(message, 0);
-      return true;
+//      return true;
     }
     else
@@ -108,5 +108,5 @@
         }
       }
-      return result;
+//      return result;
     }
   }
@@ -139,5 +139,5 @@
     for (ObjectList<ChatListener>::iterator it = ObjectList<ChatListener>::begin(); it != ObjectList<ChatListener>::end(); ++it)
       it->incomingChat(message, playerID);
-    
+
     bool result = true;
     for( std::vector<Host*>::iterator it = instances_s.begin(); it!=instances_s.end(); ++it )
Index: /code/branches/consolecommands3/src/libraries/network/Host.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/network/Host.h	(revision 7189)
+++ /code/branches/consolecommands3/src/libraries/network/Host.h	(revision 7190)
@@ -79,5 +79,5 @@
     static void setShipID(unsigned int id){ shipID_s = id; }
     static bool isServer();
-    static bool Chat(const std::string& message);
+    static void Chat(const std::string& message);
     static bool Broadcast(const std::string& message);
     static bool incomingChat(const std::string& message, unsigned int playerID);
Index: /code/branches/consolecommands3/src/libraries/util/OutputHandler.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/util/OutputHandler.h	(revision 7189)
+++ /code/branches/consolecommands3/src/libraries/util/OutputHandler.h	(revision 7190)
@@ -104,22 +104,22 @@
 
             //! Writes to all output devices
-            static inline const std::string& log(const std::string& text)
-                { OutputHandler::getOutStream(0).output(text) << std::endl; return text; }
+            static inline void log(const std::string& text)
+                { OutputHandler::getOutStream(0).output(text) << std::endl; }
 
             //! Writes an error message to the output
-            static inline const std::string& error(const std::string& text)
-                { OutputHandler::getOutStream(1).output(text) << std::endl; return text; }
+            static inline void error(const std::string& text)
+                { OutputHandler::getOutStream(1).output(text) << std::endl; }
 
             //! Writes a warning message to the output
-            static inline const std::string& warning(const std::string& text)
-                { OutputHandler::getOutStream(2).output(text) << std::endl; return text; }
+            static inline void warning(const std::string& text)
+                { OutputHandler::getOutStream(2).output(text) << std::endl; }
 
             //! Writes an informational message to the output
-            static inline const std::string& info(const std::string& text)
-                { OutputHandler::getOutStream(3).output(text) << std::endl; return text; }
+            static inline void info(const std::string& text)
+                { OutputHandler::getOutStream(3).output(text) << std::endl; }
 
             //! Writes a debug message to the output
-            static inline const std::string& debug(const std::string& text)
-                { OutputHandler::getOutStream(4).output(text) << std::endl; return text; }
+            static inline void debug(const std::string& text)
+                { OutputHandler::getOutStream(4).output(text) << std::endl; }
 
             //! Registers an object that receives output via a provided std::ostream