Index: trunk/src/world_entities/weapons/aim.cc
===================================================================
--- trunk/src/world_entities/weapons/aim.cc	(revision 7130)
+++ trunk/src/world_entities/weapons/aim.cc	(revision 7193)
@@ -18,5 +18,5 @@
 #include "aim.h"
 
-#include "load_param.h"
+#include "util/loading/load_param.h"
 #include "graphics_engine.h"
 #include "state.h"
Index: trunk/src/world_entities/weapons/aiming_turret.cc
===================================================================
--- trunk/src/world_entities/weapons/aiming_turret.cc	(revision 7130)
+++ trunk/src/world_entities/weapons/aiming_turret.cc	(revision 7193)
@@ -25,5 +25,5 @@
 #include "animation3d.h"
 
-#include "factory.h"
+#include "util/loading/factory.h"
 
 CREATE_FACTORY(AimingTurret, CL_AIMING_TURRET);
Index: trunk/src/world_entities/weapons/cannon.cc
===================================================================
--- trunk/src/world_entities/weapons/cannon.cc	(revision 7130)
+++ trunk/src/world_entities/weapons/cannon.cc	(revision 7193)
@@ -27,5 +27,5 @@
 #include "world_entities/projectiles/projectile.h"
 #include "weapon_manager.h"
-#include "factory.h"
+#include "util/loading/factory.h"
 
 #include "vector.h"
Index: trunk/src/world_entities/weapons/crosshair.cc
===================================================================
--- trunk/src/world_entities/weapons/crosshair.cc	(revision 7130)
+++ trunk/src/world_entities/weapons/crosshair.cc	(revision 7193)
@@ -19,5 +19,5 @@
 #include "event_handler.h"
 
-#include "load_param.h"
+#include "util/loading/load_param.h"
 #include "graphics_engine.h"
 #include "glincl.h"
Index: trunk/src/world_entities/weapons/hyperblaster.cc
===================================================================
--- trunk/src/world_entities/weapons/hyperblaster.cc	(revision 7130)
+++ trunk/src/world_entities/weapons/hyperblaster.cc	(revision 7193)
@@ -27,5 +27,5 @@
 #include "world_entities/projectiles/projectile.h"
 #include "weapon_manager.h"
-#include "factory.h"
+#include "util/loading/factory.h"
 
 #include "animation3d.h"
Index: trunk/src/world_entities/weapons/targeting_turret.cc
===================================================================
--- trunk/src/world_entities/weapons/targeting_turret.cc	(revision 7130)
+++ trunk/src/world_entities/weapons/targeting_turret.cc	(revision 7193)
@@ -25,5 +25,5 @@
 #include "animation3d.h"
 
-#include "factory.h"
+#include "util/loading/factory.h"
 
 CREATE_FACTORY(TargetingTurret, CL_TARGETING_TURRET);
Index: trunk/src/world_entities/weapons/test_gun.cc
===================================================================
--- trunk/src/world_entities/weapons/test_gun.cc	(revision 7130)
+++ trunk/src/world_entities/weapons/test_gun.cc	(revision 7193)
@@ -27,5 +27,5 @@
 #include "static_model.h"
 #include "weapon_manager.h"
-#include "factory.h"
+#include "util/loading/factory.h"
 
 #include "animation3d.h"
Index: trunk/src/world_entities/weapons/turret.cc
===================================================================
--- trunk/src/world_entities/weapons/turret.cc	(revision 7130)
+++ trunk/src/world_entities/weapons/turret.cc	(revision 7193)
@@ -25,5 +25,5 @@
 #include "animation3d.h"
 
-#include "factory.h"
+#include "util/loading/factory.h"
 
 CREATE_FACTORY(Turret, CL_TURRET);
Index: trunk/src/world_entities/weapons/weapon.cc
===================================================================
--- trunk/src/world_entities/weapons/weapon.cc	(revision 7130)
+++ trunk/src/world_entities/weapons/weapon.cc	(revision 7193)
@@ -24,7 +24,7 @@
 #include "world_entities/projectiles/projectile.h"
 
-#include "resource_manager.h"
+#include "util/loading/resource_manager.h"
 #include "class_list.h"
-#include "load_param.h"
+#include "util/loading/load_param.h"
 #include "state.h"
 #include "animation3d.h"
Index: trunk/src/world_entities/weapons/weapon_manager.cc
===================================================================
--- trunk/src/world_entities/weapons/weapon_manager.cc	(revision 7130)
+++ trunk/src/world_entities/weapons/weapon_manager.cc	(revision 7193)
@@ -25,6 +25,6 @@
 #include "playable.h"
 
-#include "load_param.h"
-#include "factory.h"
+#include "util/loading/load_param.h"
+#include "util/loading/factory.h"
 
 #include "t_animation.h"