Index: /code/branches/consolecommands3/src/libraries/core/Executor.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/Executor.cc	(revision 7200)
+++ /code/branches/consolecommands3/src/libraries/core/Executor.cc	(revision 7201)
@@ -39,17 +39,12 @@
 namespace orxonox
 {
-    int Functor::instances_s = 0;
-    int Executor::instances_s = 0;
-
     Executor::Executor(const FunctorPtr& functor, const std::string& name)
     {
         this->functor_ = functor;
         this->name_ = name;
-        ++instances_s; COUT(0) << "executor ++: " << instances_s << std::endl;
     }
 
     Executor::~Executor()
     {
-        --instances_s; COUT(0) << "executor --: " << instances_s << std::endl;
     }
 
Index: /code/branches/consolecommands3/src/libraries/core/Executor.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/Executor.h	(revision 7200)
+++ /code/branches/consolecommands3/src/libraries/core/Executor.h	(revision 7201)
@@ -109,7 +109,4 @@
             std::string name_;
             MultiType defaultValue_[MAX_FUNCTOR_ARGUMENTS];
-
-        private:
-            static int instances_s;
     };
 
Index: /code/branches/consolecommands3/src/libraries/core/Functor.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/Functor.h	(revision 7200)
+++ /code/branches/consolecommands3/src/libraries/core/Functor.h	(revision 7201)
@@ -102,6 +102,6 @@
 
         public:
-            Functor() { ++instances_s; COUT(0) << "functor ++: " << instances_s << std::endl; }
-            virtual ~Functor() { --instances_s; COUT(0) << "functor --: " << instances_s << std::endl; }
+            Functor() {}
+            virtual ~Functor() {}
 
             virtual MultiType operator()(const MultiType& param1 = MT_Type::Null, const MultiType& param2 = MT_Type::Null, const MultiType& param3 = MT_Type::Null, const MultiType& param4 = MT_Type::Null, const MultiType& param5 = MT_Type::Null) = 0;
@@ -120,7 +120,4 @@
 
             virtual const std::type_info& getHeaderIdentifier() const = 0;
-
-        private:
-            static int instances_s;
     };
 
Index: /code/branches/consolecommands3/src/libraries/core/FunctorPtr.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/FunctorPtr.h	(revision 7200)
+++ /code/branches/consolecommands3/src/libraries/core/FunctorPtr.h	(revision 7201)
@@ -45,30 +45,6 @@
             inline FunctorMemberPtr() : SharedChildPtr<FunctorMember<T>, FunctorPtr>() {}
             inline FunctorMemberPtr(FunctorMember<T>* pointer) : SharedChildPtr<FunctorMember<T>, FunctorPtr>(pointer) {}
-//            inline FunctorMemberPtr(const FunctorMemberPtr& other) : SharedChildPtr<FunctorMember<T>, FunctorPtr>(other) {}
-//            template <class O>
-//            inline FunctorMemberPtr(const SharedPtr<O>& other) : SharedChildPtr<FunctorMember<T>, FunctorPtr>(other) {}
-//            template <class O>
-//            inline FunctorMemberPtr(const SharedChildPtr<O, FunctorMember<T> >& other) : SharedChildPtr<FunctorMember<T>, FunctorPtr>(other) {}
             inline FunctorMemberPtr(const SharedPtr<FunctorMember<T> >& other) : SharedChildPtr<FunctorMember<T>, FunctorPtr>(other) {}
-
-/*
-            inline const FunctorMemberPtr& operator=(const FunctorMemberPtr& other) { this->SharedChildPtr<FunctorMember<T>, FunctorPtr>::operator=(other); return *this; }
-            template <class O>
-            inline const FunctorMemberPtr& operator=(const SharedPtr<O>& other) { this->SharedChildPtr<FunctorMember<T>, FunctorPtr>::operator=(other); return *this; }
-*/
-        private:
-//            inline FunctorMemberPtr(FunctorMember<T>* pointer, int* counter) : SharedChildPtr<FunctorMember<T>, FunctorPtr>(pointer, counter) {}
     };
-/*
-    typedef SharedChildPtr<FunctorStatic, Functor> FunctorStaticPtr;
-
-    template <class T>
-    class FunctorMemberPtr : public SharedChildPtr<FunctorMember<T>, Functor>
-    {
-        public:
-            inline FunctorMemberPtr() : SharedChildPtr<FunctorMember<T>, Functor>() {}
-            inline FunctorMemberPtr(FunctorMember<T>* pointer) : SharedChildPtr<FunctorMember<T>, Functor>(pointer) {}
-    };
-*/
 }
 
Index: /code/branches/consolecommands3/src/libraries/core/SharedPtr.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/SharedPtr.h	(revision 7200)
+++ /code/branches/consolecommands3/src/libraries/core/SharedPtr.h	(revision 7201)
@@ -50,5 +50,4 @@
             void destroy()
             {
-//                COUT(0) << "delete " << this->pointer_ << std::endl;
                 delete this->pointer_;
             }
@@ -67,10 +66,8 @@
             inline SharedPtr() : pointer_(0), counter_(0), destroyer_(0)
             {
-//                COUT(0) << "SharedPtr (1): " << this->pointer_ << std::endl;
             }
 
             inline SharedPtr(T* pointer) : pointer_(pointer), counter_(0), destroyer_(0)
             {
-//                COUT(0) << "SharedPtr (2): " << this->pointer_ << std::endl;
                 if (this->pointer_)
                 {
@@ -82,5 +79,4 @@
             inline SharedPtr(const SharedPtr& other) : pointer_(other.pointer_), counter_(other.counter_), destroyer_(other.destroyer_)
             {
-//                COUT(0) << "SharedPtr (3): " << this->pointer_ << std::endl;
                 if (this->pointer_)
                     ++(*this->counter_);
@@ -90,5 +86,4 @@
             inline SharedPtr(const SharedPtr<O>& other) : pointer_(other.pointer_), counter_(other.counter_), destroyer_(other.destroyer_)
             {
-//                COUT(0) << "SharedPtr (4): " << this->pointer_ << std::endl;
                 if (this->pointer_)
                     ++(*this->counter_);
@@ -97,5 +92,4 @@
             inline ~SharedPtr()
             {
-//                COUT(0) << "~SharedPtr: " << this->pointer_ << std::endl;
                 if (this->pointer_)
                 {
@@ -113,5 +107,4 @@
             inline const SharedPtr& operator=(const SharedPtr& other)
             {
-//                COUT(0) << "SharedPtr= (1)" << std::endl;
                 SharedPtr(other).swap(*this);
                 return *this;
@@ -121,5 +114,4 @@
             inline const SharedPtr& operator=(const SharedPtr<O>& other)
             {
-//                COUT(0) << "SharedPtr= (2)" << std::endl;
                 SharedPtr(other).swap(*this);
                 return *this;
@@ -160,5 +152,4 @@
             inline SharedPtr(T* pointer, int* counter, SharedPtrDestroyer* destroyer) : pointer_(pointer), counter_(counter), destroyer_(destroyer)
             {
-//                COUT(0) << "SharedPtr (5): " << this->pointer_ << std::endl;
                 if (this->pointer_)
                     ++(*this->counter_);
@@ -176,10 +167,5 @@
             inline SharedChildPtr() : Parent() {}
             inline SharedChildPtr(T* pointer) : Parent(pointer) {}
-//            inline SharedChildPtr(const SharedChildPtr& other) : Parent(other) {}
-//            template <class O>
-//            inline SharedChildPtr(const SharedChildPtr<O, T>& other) : Parent(other) {}
             inline SharedChildPtr(const SharedPtr<T>& other) : Parent(other) {}
-
-//            inline const SharedChildPtr& operator=(const SharedChildPtr& other) { Parent::operator=(other); return *this; }
 
             inline T* operator->() const { return static_cast<T*>(Parent::operator->()); }