Index: /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompleter.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompleter.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompleter.h	(revision 7203)
@@ -30,5 +30,5 @@
 #define _ArgumentCompleter_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 #include "ArgumentCompletionListElement.h"
 
Index: /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompletionFunctions.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompletionFunctions.cc	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompletionFunctions.cc	(revision 7203)
@@ -35,7 +35,7 @@
 #include "util/Convert.h"
 #include "util/StringUtils.h"
-#include "Identifier.h"
-#include "ConfigFileManager.h"
-#include "ConfigValueContainer.h"
+#include "core/Identifier.h"
+#include "core/ConfigFileManager.h"
+#include "core/ConfigValueContainer.h"
 #include "TclThreadManager.h"
 
Index: /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompletionFunctions.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompletionFunctions.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompletionFunctions.h	(revision 7203)
@@ -30,5 +30,5 @@
 #define _ArgumentCompletionFunctions_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 #include "ArgumentCompleter.h"
 
Index: /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompletionListElement.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompletionListElement.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompletionListElement.h	(revision 7203)
@@ -30,5 +30,5 @@
 #define _ArgumentCompletionListElement_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 #include <list>
Index: /code/branches/consolecommands3/src/libraries/core/command/CommandEvaluation.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/CommandEvaluation.cc	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/CommandEvaluation.cc	(revision 7203)
@@ -31,6 +31,6 @@
 #include "util/Debug.h"
 #include "util/StringUtils.h"
+#include "core/Identifier.h"
 #include "ConsoleCommand.h"
-#include "Identifier.h"
 
 namespace orxonox
Index: /code/branches/consolecommands3/src/libraries/core/command/CommandEvaluation.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/CommandEvaluation.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/CommandEvaluation.h	(revision 7203)
@@ -30,5 +30,5 @@
 #define _CommandEvaluation_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 #include <string>
Index: /code/branches/consolecommands3/src/libraries/core/command/CommandExecutor.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/CommandExecutor.cc	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/CommandExecutor.cc	(revision 7203)
@@ -31,7 +31,7 @@
 #include "util/Debug.h"
 #include "util/StringUtils.h"
+#include "core/Identifier.h"
+#include "core/Language.h"
 #include "ConsoleCommand.h"
-#include "Identifier.h"
-#include "Language.h"
 #include "TclBind.h"
 
Index: /code/branches/consolecommands3/src/libraries/core/command/CommandExecutor.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/CommandExecutor.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/CommandExecutor.h	(revision 7203)
@@ -30,5 +30,5 @@
 #define _CommandExecutor_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 #include <map>
Index: /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommand.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommand.cc	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommand.cc	(revision 7203)
@@ -30,5 +30,5 @@
 #include <cassert>
 
-#include "Language.h"
+#include "core/Language.h"
 
 namespace orxonox
@@ -117,5 +117,5 @@
 }
 
-#include "BaseObject.h" // remove this
+#include "core/BaseObject.h" // remove this
 
 namespace orxonox
Index: /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommand.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommand.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommand.h	(revision 7203)
@@ -30,5 +30,5 @@
 #define _ConsoleCommand_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 #include <stack>
@@ -37,8 +37,8 @@
 
 #include "util/VA_NARGS.h"
+#include "core/Identifier.h"
 #include "ArgumentCompletionFunctions.h"
 #include "CommandExecutor.h"
 #include "Executor.h"
-#include "Identifier.h"
 
 
Index: /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommandCompilation.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommandCompilation.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommandCompilation.h	(revision 7203)
@@ -30,5 +30,5 @@
 #define _ConsoleCommandCompilation_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 namespace orxonox
Index: /code/branches/consolecommands3/src/libraries/core/command/Executor.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/Executor.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/Executor.h	(revision 7203)
@@ -31,5 +31,5 @@
 #define _Executor_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 #include <string>
Index: /code/branches/consolecommands3/src/libraries/core/command/ExecutorPtr.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/ExecutorPtr.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/ExecutorPtr.h	(revision 7203)
@@ -30,6 +30,6 @@
 #define _ExecutorPtr_H__
 
-#include "CorePrereqs.h"
-#include "SharedPtr.h"
+#include "core/CorePrereqs.h"
+#include "core/SharedPtr.h"
 
 namespace orxonox
Index: /code/branches/consolecommands3/src/libraries/core/command/Functor.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/Functor.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/Functor.h	(revision 7203)
@@ -33,5 +33,5 @@
 #include <typeinfo>
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 #include "util/Convert.h"
Index: /code/branches/consolecommands3/src/libraries/core/command/FunctorPtr.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/FunctorPtr.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/FunctorPtr.h	(revision 7203)
@@ -30,6 +30,6 @@
 #define _FunctorPtr_H__
 
-#include "CorePrereqs.h"
-#include "SharedPtr.h"
+#include "core/CorePrereqs.h"
+#include "core/SharedPtr.h"
 
 namespace orxonox
Index: /code/branches/consolecommands3/src/libraries/core/command/IOConsole.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/IOConsole.cc	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/IOConsole.cc	(revision 7203)
@@ -35,6 +35,6 @@
 #include "util/Clock.h"
 #include "util/Math.h"
-#include "Game.h"
-#include "input/InputBuffer.h"
+#include "core/Game.h"
+#include "core/input/InputBuffer.h"
 
 // ##########################
Index: /code/branches/consolecommands3/src/libraries/core/command/IOConsole.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/IOConsole.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/IOConsole.h	(revision 7203)
@@ -31,5 +31,5 @@
 #define _IOConsole_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 #include <sstream>
Index: /code/branches/consolecommands3/src/libraries/core/command/IRC.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/IRC.cc	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/IRC.cc	(revision 7203)
@@ -34,6 +34,6 @@
 #include "util/Exception.h"
 #include "util/StringUtils.h"
+#include "core/CoreIncludes.h"
 #include "ConsoleCommand.h"
-#include "CoreIncludes.h"
 #include "TclThreadManager.h"
 
Index: /code/branches/consolecommands3/src/libraries/core/command/IRC.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/IRC.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/IRC.h	(revision 7203)
@@ -30,8 +30,8 @@
 #define _IRC_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 #include <string>
-#include "OrxonoxClass.h"
+#include "core/OrxonoxClass.h"
 
 namespace orxonox
Index: /code/branches/consolecommands3/src/libraries/core/command/Shell.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/Shell.cc	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/Shell.cc	(revision 7203)
@@ -32,8 +32,8 @@
 #include "util/StringUtils.h"
 #include "util/SubString.h"
+#include "core/CoreIncludes.h"
+#include "core/ConfigFileManager.h"
+#include "core/ConfigValueIncludes.h"
 #include "CommandExecutor.h"
-#include "CoreIncludes.h"
-#include "ConfigFileManager.h"
-#include "ConfigValueIncludes.h"
 #include "ConsoleCommand.h"
 
Index: /code/branches/consolecommands3/src/libraries/core/command/Shell.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/Shell.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/Shell.h	(revision 7203)
@@ -30,5 +30,5 @@
 #define _Shell_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 #include <list>
@@ -38,6 +38,6 @@
 
 #include "util/OutputHandler.h"
-#include "OrxonoxClass.h"
-#include "input/InputBuffer.h"
+#include "core/OrxonoxClass.h"
+#include "core/input/InputBuffer.h"
 
 namespace orxonox
Index: /code/branches/consolecommands3/src/libraries/core/command/TclBind.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/TclBind.cc	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/TclBind.cc	(revision 7203)
@@ -37,7 +37,7 @@
 #include "util/Exception.h"
 #include "util/StringUtils.h"
+#include "core/PathConfig.h"
 #include "CommandExecutor.h"
 #include "ConsoleCommand.h"
-#include "PathConfig.h"
 #include "TclThreadManager.h"
 
Index: /code/branches/consolecommands3/src/libraries/core/command/TclBind.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/TclBind.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/TclBind.h	(revision 7203)
@@ -30,5 +30,5 @@
 #define _TclBind_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 #include <cassert>
Index: /code/branches/consolecommands3/src/libraries/core/command/TclThreadList.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/TclThreadList.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/TclThreadList.h	(revision 7203)
@@ -30,5 +30,5 @@
 #define _TclThreadList_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 #include <list>
Index: /code/branches/consolecommands3/src/libraries/core/command/TclThreadManager.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/TclThreadManager.cc	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/TclThreadManager.cc	(revision 7203)
@@ -40,7 +40,7 @@
 #include "util/Exception.h"
 #include "util/StringUtils.h"
+#include "core/CoreIncludes.h"
 #include "CommandExecutor.h"
 #include "ConsoleCommand.h"
-#include "CoreIncludes.h"
 #include "TclBind.h"
 #include "TclThreadList.h"
Index: /code/branches/consolecommands3/src/libraries/core/command/TclThreadManager.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/TclThreadManager.h	(revision 7202)
+++ /code/branches/consolecommands3/src/libraries/core/command/TclThreadManager.h	(revision 7203)
@@ -30,5 +30,5 @@
 #define _TclThreadManager_H__
 
-#include "CorePrereqs.h"
+#include "core/CorePrereqs.h"
 
 #include <cassert>
@@ -38,5 +38,5 @@
 
 #include "util/Singleton.h"
-#include "OrxonoxClass.h"
+#include "core/OrxonoxClass.h"
 
 struct Tcl_Interp;