Index: code/branches/consolecommands3/src/orxonox/Test.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/Test.cc	(revision 7178)
+++ code/branches/consolecommands3/src/orxonox/Test.cc	(revision 7204)
@@ -29,5 +29,5 @@
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
-#include "core/ConsoleCommand.h"
+#include "core/command/ConsoleCommand.h"
 #include "network/NetworkFunction.h"
 #include "Test.h"
@@ -37,5 +37,5 @@
 {
     CreateFactory ( Test );
-  
+
     SetConsoleCommand(Test, printV1, true).accessLevel(AccessLevel::User);
     SetConsoleCommand(Test, printV2, true).accessLevel(AccessLevel::User);
@@ -44,14 +44,14 @@
     SetConsoleCommand(Test, call, true).accessLevel(AccessLevel::User);
     SetConsoleCommand(Test, call2, true).accessLevel(AccessLevel::User);
-  
-  
+
+
   //void=* aaaaa = copyPtr<sizeof(&Test::printV1)>( &NETWORK_FUNCTION_POINTER, &Test::printV1 );
   //void* NETWORK_FUNCTION_TEST_B = memcpy(&NETWORK_FUNCTION_POINTER, &a, sizeof(a));
 //   NetworkFunctionBase* NETWORK_FUNCTION_TEST_C = new NetworkFunctionStatic( createFunctor(&Test::printV1), "bla", NETWORK_FUNCTION_POINTER );
-  
+
     registerStaticNetworkFunction( &Test::printV1 );
     registerMemberNetworkFunction( Test, checkU1 );
     registerMemberNetworkFunction( Test, printBlaBla );
-  
+
     Test* Test::instance_ = 0;
 
@@ -78,5 +78,5 @@
         SetConfigValue ( u3, 3 )/*.callback ( this, &Test::checkV3 )*/;
         SetConfigValue ( u4, 4 )/*.callback ( this, &Test::checkV4 )*/;
-    
+
         SetConfigValue ( s1, 1 )/*.callback ( this, &Test::checkV1 )*/;
         SetConfigValue ( s2, 2 )/*.callback ( this, &Test::checkV2 )*/;
@@ -89,18 +89,18 @@
     {
         registerVariable ( this->mySet_, VariableDirection::ToClient );
-      
+
 //         registerVariable ( u1, VariableDirection::ToClient, new NetworkCallback<Test> ( this, &Test::checkU1 ));
 //         registerVariable ( u2, VariableDirection::ToServer, new NetworkCallback<Test> ( this, &Test::checkU2 ));
 //         registerVariable ( u3, Bidirectionality::ServerMaster, new NetworkCallback<Test> ( this, &Test::checkU3 ), true );
 //         registerVariable ( u4, Bidirectionality::ClientMaster, new NetworkCallback<Test> ( this, &Test::checkU4 ), true );
-    
+
 //         registerVariable ( s1, VariableDirection::ToClient, new NetworkCallback<Test> ( this, &Test::checkS1 ));
 //         registerVariable ( s2, VariableDirection::ToServer, new NetworkCallback<Test> ( this, &Test::checkS2 ));
 //         registerVariable ( s3, Bidirectionality::ServerMaster, new NetworkCallback<Test> ( this, &Test::checkS3 ), true );
 //         registerVariable ( s4, Bidirectionality::ClientMaster, new NetworkCallback<Test> ( this, &Test::checkS4 ), true );
-    
+
 //         registerVariable ( pointer_, VariableDirection::ToClient, new NetworkCallback<Test> ( this, &Test::printPointer ) );
     }
-  
+
   void Test::call(unsigned int clientID)
     {
@@ -108,10 +108,10 @@
         callStaticNetworkFunction( &Test::printV1, clientID );
     }
-  
+
     void Test::call2(unsigned int clientID, std::string s1, std::string s2, std::string s3, std::string s4)
     {
         callMemberNetworkFunction( Test, printBlaBla, this->getObjectID(), clientID, s1, s2, s3, s4, s4 );
     }
-  
+
     void Test::tick(float dt)
     {
@@ -132,10 +132,10 @@
     //       callMemberNetworkFunction( Test, checkU1, this->getObjectID(), 0 );
     }
-    
+
     void Test::printBlaBla(std::string s1, std::string s2, std::string s3, std::string s4, std::string s5)
     {
         COUT(0) << s1 << s2 << s3 << s4 << s5 << endl;
     }
-    
+
     void Test::checkU1(){ COUT(1) << "U1 changed: " << u1 << std::endl; }
     void Test::checkU2(){ COUT(1) << "U2 changed: " << u2 << std::endl; }
@@ -147,5 +147,5 @@
     void Test::checkS3(){ COUT(1) << "S3 changed: " << s3 << std::endl; }
     void Test::checkS4(){ COUT(1) << "S4 changed: " << s4 << std::endl; }
-    
+
     void Test::printPointer(){ CCOUT(1) << "pointer: " << this->pointer_ << endl; }
 