Index: code/branches/consolecommands3/src/orxonox/CameraManager.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/CameraManager.cc	(revision 7204)
+++ code/branches/consolecommands3/src/orxonox/CameraManager.cc	(revision 7207)
@@ -34,9 +34,9 @@
 
 #include "util/StringUtils.h"
+#include "util/ScopedSingletonManager.h"
 #include "core/GameMode.h"
 #include "core/GraphicsManager.h"
 #include "core/GUIManager.h"
 #include "core/ObjectList.h"
-#include "core/ScopedSingletonManager.h"
 #include "tools/Shader.h"
 #include "graphics/Camera.h"
Index: code/branches/consolecommands3/src/orxonox/ChatHistory.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/ChatHistory.cc	(revision 7204)
+++ code/branches/consolecommands3/src/orxonox/ChatHistory.cc	(revision 7207)
@@ -28,5 +28,5 @@
 
 #include "ChatHistory.h"
-#include <core/ScopedSingletonManager.h>
+#include "util/ScopedSingletonManager.h"
 
 #ifndef CHATTEST
Index: code/branches/consolecommands3/src/orxonox/ChatInputHandler.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/ChatInputHandler.cc	(revision 7204)
+++ code/branches/consolecommands3/src/orxonox/ChatInputHandler.cc	(revision 7207)
@@ -28,5 +28,5 @@
 
 #include "ChatInputHandler.h"
-#include <core/ScopedSingletonManager.h>
+#include "util/ScopedSingletonManager.h"
 #include "core/CoreIncludes.h"
 #include "core/GUIManager.h"
Index: code/branches/consolecommands3/src/orxonox/LevelManager.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/LevelManager.cc	(revision 7204)
+++ code/branches/consolecommands3/src/orxonox/LevelManager.cc	(revision 7207)
@@ -31,4 +31,5 @@
 #include <map>
 
+#include "util/ScopedSingletonManager.h"
 #include "core/CommandLineParser.h"
 #include "core/ConfigValueIncludes.h"
@@ -36,5 +37,4 @@
 #include "core/Loader.h"
 #include "core/Resource.h"
-#include "core/ScopedSingletonManager.h"
 #include "PlayerManager.h"
 #include "Level.h"
Index: code/branches/consolecommands3/src/orxonox/MoodManager.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/MoodManager.cc	(revision 7204)
+++ code/branches/consolecommands3/src/orxonox/MoodManager.cc	(revision 7207)
@@ -29,7 +29,7 @@
 #include "MoodManager.h"
 
+#include "util/ScopedSingletonManager.h"
 #include "core/ConfigValueIncludes.h"
 #include "core/CoreIncludes.h"
-#include "core/ScopedSingletonManager.h"
 #include "core/Resource.h"
 
@@ -48,5 +48,5 @@
         // Need to use a variable to store old data because ResetConfigValues() doesn't seem to work.
         oldMood_ = MoodManager::defaultMood_;
-        
+
         // Checking for the existence of the folder for the default mood
         const std::string& path = "ambient/" + MoodManager::defaultMood_ + "/.";
Index: code/branches/consolecommands3/src/orxonox/PlayerManager.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/PlayerManager.cc	(revision 7204)
+++ code/branches/consolecommands3/src/orxonox/PlayerManager.cc	(revision 7207)
@@ -29,7 +29,7 @@
 #include "PlayerManager.h"
 
+#include "util/ScopedSingletonManager.h"
 #include "core/CoreIncludes.h"
 #include "core/GameMode.h"
-#include "core/ScopedSingletonManager.h"
 #include "Level.h"
 #include "infos/HumanPlayer.h"
Index: code/branches/consolecommands3/src/orxonox/overlays/InGameConsole.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/overlays/InGameConsole.cc	(revision 7204)
+++ code/branches/consolecommands3/src/orxonox/overlays/InGameConsole.cc	(revision 7207)
@@ -45,7 +45,7 @@
 #include "util/Math.h"
 #include "util/DisplayStringConversions.h"
+#include "util/ScopedSingletonManager.h"
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
-#include "core/ScopedSingletonManager.h"
 #include "core/command/ConsoleCommand.h"
 #include "core/input/InputManager.h"
Index: code/branches/consolecommands3/src/orxonox/sound/SoundManager.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/sound/SoundManager.cc	(revision 7204)
+++ code/branches/consolecommands3/src/orxonox/sound/SoundManager.cc	(revision 7207)
@@ -38,8 +38,8 @@
 #include "util/ScopeGuard.h"
 #include "util/Clock.h"
+#include "util/ScopedSingletonManager.h"
 #include "core/ConfigValueIncludes.h"
 #include "core/CoreIncludes.h"
 #include "core/GameMode.h"
-#include "core/ScopedSingletonManager.h"
 #include "core/Resource.h"
 #include "SoundBuffer.h"