Index: data/branches/png2/gui/imagesets/FairChar.imageset
===================================================================
--- data/branches/png2/gui/imagesets/FairChar.imageset	(revision 7257)
+++ data/branches/png2/gui/imagesets/FairChar.imageset	(revision 7259)
@@ -1,4 +1,4 @@
 <?xml version="1.0" ?>
-<Imageset Name="FairChar" Imagefile="FairChar.tga" NativeHorzRes="800" NativeVertRes="600" AutoScaled="true">
+<Imageset Name="FairChar" Imagefile="FairChar.png" NativeHorzRes="800" NativeVertRes="600" AutoScaled="true">
 	<Image Name=" " XPos="0"   YPos="0"  Width="0"  Height="0" />
 	<Image Name="A" XPos="4"   YPos="1"  Width="30" Height="30" YOffset="-30" />
Index: data/branches/png2/gui/imagesets/PickupInventory.imageset
===================================================================
--- data/branches/png2/gui/imagesets/PickupInventory.imageset	(revision 7257)
+++ data/branches/png2/gui/imagesets/PickupInventory.imageset	(revision 7259)
@@ -1,4 +1,4 @@
 <?xml version="1.0" ?>
-<Imageset Name="PickupInventory" Imagefile="pickup.tga" NativeHorzRes="1600" NativeVertRes="100" AutoScaled="true">
+<Imageset Name="PickupInventory" Imagefile="pickup.png" NativeHorzRes="1600" NativeVertRes="100" AutoScaled="true">
     <Image Name="Default" XPos="0" YPos="0" Width="100" Height="100"/>
 
Index: data/branches/png2/gui/imagesets/ReadMe.txt
===================================================================
--- data/branches/png2/gui/imagesets/ReadMe.txt	(revision 7257)
+++ data/branches/png2/gui/imagesets/ReadMe.txt	(revision 7259)
@@ -1,6 +1,6 @@
 The images in this directory were obtained from various sources...
 
-GPN-2000-001437.tga		- From GRIN (http://grin.hq.nasa.gov/)
-TaharezLook.tga			- Original Taharez imagery created by Lars "Taharez" Rinde.
-WindowsLook.tga			- Windows look imagery created by Paul "CrazyEddie" Turner.
-vanilla.tga				- Original "Vanilla GUI" imagery created by Shane Parker, used with permission.
+GPN-2000-001437.png		- From GRIN (http://grin.hq.nasa.gov/)
+TaharezLook.png			- Original Taharez imagery created by Lars "Taharez" Rinde.
+WindowsLook.png			- Windows look imagery created by Paul "CrazyEddie" Turner.
+vanilla.png				- Original "Vanilla GUI" imagery created by Shane Parker, used with permission.
Index: data/branches/png2/gui/imagesets/TaharezGreenLook.imageset
===================================================================
--- data/branches/png2/gui/imagesets/TaharezGreenLook.imageset	(revision 7257)
+++ data/branches/png2/gui/imagesets/TaharezGreenLook.imageset	(revision 7259)
@@ -1,4 +1,4 @@
 <?xml version="1.0" ?>
-<Imageset Name="TaharezGreenLook" Imagefile="TaharezGreenLook.tga" NativeHorzRes="800" NativeVertRes="600" AutoScaled="true">
+<Imageset Name="TaharezGreenLook" Imagefile="TaharezGreenLook.png" NativeHorzRes="800" NativeVertRes="600" AutoScaled="true">
     <Image Name="ClientBrush" XPos="2" YPos="2" Width="64" Height="64" />
     <Image Name="GenericBrush" XPos="9" YPos="71" Width="1" Height="1" />
Index: data/branches/png2/gui/imagesets/TaharezLook.imageset
===================================================================
--- data/branches/png2/gui/imagesets/TaharezLook.imageset	(revision 7257)
+++ data/branches/png2/gui/imagesets/TaharezLook.imageset	(revision 7259)
@@ -1,4 +1,4 @@
 <?xml version="1.0" ?>
-<Imageset Name="TaharezLook" Imagefile="TaharezLook.tga" NativeHorzRes="800" NativeVertRes="600" AutoScaled="true">
+<Imageset Name="TaharezLook" Imagefile="TaharezLook.png" NativeHorzRes="800" NativeVertRes="600" AutoScaled="true">
     <Image Name="ClientBrush" XPos="2" YPos="2" Width="64" Height="64" />
     <Image Name="GenericBrush" XPos="9" YPos="71" Width="1" Height="1" />
Index: data/branches/png2/gui/imagesets/Vanilla.imageset
===================================================================
--- data/branches/png2/gui/imagesets/Vanilla.imageset	(revision 7257)
+++ data/branches/png2/gui/imagesets/Vanilla.imageset	(revision 7259)
@@ -1,4 +1,4 @@
 <?xml version="1.0" ?>
-<Imageset Name="Vanilla-Images" Imagefile="vanilla.tga" NativeHorzRes="800" NativeVertRes="600" AutoScaled="true">
+<Imageset Name="Vanilla-Images" Imagefile="vanilla.png" NativeHorzRes="800" NativeVertRes="600" AutoScaled="true">
 	<Image Name="GenericBrush" XPos="46" YPos="46" Width="3" Height="3" />
 	<Image Name="FrameTopLeft" XPos="1" YPos="1" Width="6" Height="6" />
Index: data/branches/png2/gui/imagesets/WindowsLook.imageset
===================================================================
--- data/branches/png2/gui/imagesets/WindowsLook.imageset	(revision 7257)
+++ data/branches/png2/gui/imagesets/WindowsLook.imageset	(revision 7259)
@@ -1,4 +1,4 @@
 <?xml version="1.0" ?>
-<Imageset Name="WindowsLook" Imagefile="WindowsLook.tga" NativeHorzRes="800" NativeVertRes="600" AutoScaled="true">
+<Imageset Name="WindowsLook" Imagefile="WindowsLook.png" NativeHorzRes="800" NativeVertRes="600" AutoScaled="true">
 	<Image Name="Background" XPos="9" YPos="9" Width="2" Height="2" />
 	<Image Name="WindowFrameLeft" XPos="2" YPos="9" Width="4" Height="2" />